<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 17/11/2014
 * Time: 12:29
 */

namespace Folha\Logic\ValesBeneficios\IntegracaoEletronicaVT;


class LeitorTransfacil extends Leitor
{

    protected $formatosAceitos = 'XLSX|XLSM|XLTX|XLTM|XLS|XLT|ODS|OTS|SLK|XML';

    /**
     * Abre o arquivo que contém a informação de saldo disponível do vale-transporte.
     * @param String $caminho
     * @return mixed
     */
    protected function abrirArquivo($caminho)
    {
        /** @var \PHPExcel $info */
        $info = \PHPExcel_IOFactory::load($caminho);
        $info->setActiveSheetIndex(0);

        return $info;
    }

    /**
     * Cria um Array contendo Arrays no formato:
     * [
     *     NUMERO_CARTAO : '',
     *     SALDO_CARTAO : ''
     * ]
     * @param mixed $info
     * @return Array
     * @throws ExcessaoIntegracaoVT
     * @throws \Exception
     */
    protected function preparaInfo($info)
    {
        $idLinha = 8;
        $idColCartao = 'C';
        $idColSaldo = 'O';
        $infoFinal = array();

        $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
        $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha++)->getValue();
        while(!empty($numCartao)){
            $reg = array();
            $reg['NUMERO_CARTAO'] = $numCartao;
            $reg['SALDO_CARTAO'] = $saldo;

            $numCartao = $info->getActiveSheet()->getCell($idColCartao.$idLinha)->getValue();
            $saldo = $info->getActiveSheet()->getCell($idColSaldo.$idLinha++)->getValue();

            $infoFinal[] = $reg;
        }

        return $infoFinal;
    }

} 