ZeedhiChart.directive("zhMaps", function() {
	return {
		link: function(scope, element, attrs) {

			var map;
			var markers = [];
			var geocoder = new google.maps.Geocoder();
			
			map = new google.maps.Map(element[0], {
				zoom: 16,
			    center: {lat: -19.912998, lng: -43.940933}
			});
			
			scope.widget.map = map;

			//--------- Events ---------
			/*Geocoder for subsidiary's address.
			  It'll build up polygonCoordinates array and populate it with coordinates of a radius around the subsidiary's address.
			  Then it will construct the polygon.*/
			google.maps.event.addListenerOnce(map, 'idle', function() {
				scope.loadFirstAddressGeocode(geocoder, map);
			});

			google.maps.event.addListener(map, 'click', function(event) {
			   scope.placeMarker(event.latLng);
			});

			scope.placeMarker = function (location) {
				if(scope.widget.edit){
					for(let i = 0; i < markers.length; i++){
						markers[i].setMap(null);
					}

				    var marker = new google.maps.Marker({
				        position: location, 
				        map: map
				    });

				    markers.push(marker);

				    scope.widget.coordinates.lat = location.lat();
				    scope.widget.coordinates.lng = location.lng();
				}
			};

			scope.loadFirstAddressGeocode = function(geocoder, resultsMap) {
				var location, marker;

				if(scope.widget.coordinates.lat !== "" && scope.widget.coordinates.lng !== ""){
					location = new google.maps.LatLng(parseFloat(scope.widget.coordinates.lat), parseFloat(scope.widget.coordinates.lng));

					marker = new google.maps.Marker({
				        position: location, 
				        map: map
				    });

				    markers.push(marker);

					resultsMap.setCenter(location);
				}
			};

			scope.geocodeAddress = function(geocoder, resultsMap) {
				var address = document.getElementById('address').value;
				if(address !== ""){
					geocoder.geocode({'address': address}, function(results, status) {
						if (status === google.maps.GeocoderStatus.OK) {
								resultsMap.setCenter(results[0].geometry.location);
								var marker = new google.maps.Marker({
									map: resultsMap,
									position: results[0].geometry.location
								});
						} else {
							alert('Endereço não encontrado.');
						}
					});
				} else {
					alert('Endereço não encontrado.');
				}
			};

			/*Getter for user's address input.*/
			document.getElementById('submit').addEventListener('click', function() {
				scope.geocodeAddress(geocoder, map);
			});
		}

	};
});